<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.7" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="flash__map__backend_8h" kind="file">
    <compoundname>flash_map_backend.h</compoundname>
    <includes local="yes" refid="mcuboot__config_8h">mcuboot_config/mcuboot_config.h</includes>
    <includes local="yes">cy_flash.h</includes>
    <includes local="no">inttypes.h</includes>
    <includedby local="yes" refid="bootutil__priv_8h">bootutil_priv.h</includedby>
    <includedby local="yes" refid="cy__smif__psoc6_8h">cy_smif_psoc6.h</includedby>
    <incdepgraph>
      <node id="31">
        <label>cy_flash.h</label>
      </node>
      <node id="30">
        <label>flash_map_backend.h</label>
        <link refid="flash_map_backend.h" />
        <childnode refid="31" relation="include">
        </childnode>
        <childnode refid="32" relation="include">
        </childnode>
      </node>
      <node id="32">
        <label>inttypes.h</label>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structflash__area">flash_area</innerclass>
    <innerclass prot="public" refid="structflash__sector">flash_sector</innerclass>
    <innerclass prot="public" refid="structflash__map__entry">flash_map_entry</innerclass>
      <sectiondef kind="define">
      <memberdef id="flash__map__backend_8h_1abe2bbb76267821057c8a78f9de62c161" kind="define" prot="public" static="no">
        <name>FLASH_DEVICE_INDEX_MASK</name>
        <initializer>(0x7F)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" bodystart="73" column="11" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="73" />
      </memberdef>
      <memberdef id="flash__map__backend_8h_1a503f4823c634bccad99a43c34edb5dab" kind="define" prot="public" static="no">
        <name>FLASH_DEVICE_GET_EXT_INDEX</name>
        <param><defname>n</defname></param>
        <initializer>((n) &amp; FLASH_DEVICE_INDEX_MASK)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" bodystart="74" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="74" />
      </memberdef>
      <memberdef id="flash__map__backend_8h_1a0ee51c5e8e7817c660a4aa3ecde3d336" kind="define" prot="public" static="no">
        <name>FLASH_DEVICE_EXTERNAL_FLAG</name>
        <initializer>(0x80)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" bodystart="75" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="75" />
      </memberdef>
      <memberdef id="flash__map__backend_8h_1aca7602fed2a8643623a89c9593759b96" kind="define" prot="public" static="no">
        <name>FLASH_DEVICE_INTERNAL_FLASH</name>
        <initializer>(0x7F)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" bodystart="76" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="76" />
      </memberdef>
      <memberdef id="flash__map__backend_8h_1acee76e52e126c46793140ddc80656169" kind="define" prot="public" static="no">
        <name>FLASH_DEVICE_EXTERNAL_FLASH</name>
        <param><defname>index</defname></param>
        <initializer>(FLASH_DEVICE_EXTERNAL_FLAG | index)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" bodystart="77" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="77" />
      </memberdef>
      <memberdef id="flash__map__backend_8h_1aeacd94d61d0b2627301b687a9537da28" kind="define" prot="public" static="no">
        <name>CY_BOOT_EXTERNAL_DEVICE_INDEX</name>
        <initializer>(0)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" bodystart="81" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="81" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1ab66041591f8ceefbd4464f1445c2bbfa" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int flash_area_open</definition>
        <argsstring>(uint8_t id, const struct flash_area **)</argsstring>
        <name>flash_area_open</name>
        <param>
          <type>uint8_t</type>
          <declname>id</declname>
        </param>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> **</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="161" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1a4de00f43876075b7a52c3095e2428504" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void flash_area_close</definition>
        <argsstring>(const struct flash_area *)</argsstring>
        <name>flash_area_close</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="162" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1ae5a3579793e3cda7ece110714931594a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int flash_area_read</definition>
        <argsstring>(const struct flash_area *, uint32_t off, void *dst, uint32_t len)</argsstring>
        <name>flash_area_read</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>off</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>dst</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>len</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="164" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1ad7daab5dcb122b8cdf50b317f8cf6214" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int flash_area_write</definition>
        <argsstring>(const struct flash_area *, uint32_t off, const void *src, uint32_t len)</argsstring>
        <name>flash_area_write</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>off</declname>
        </param>
        <param>
          <type>const void *</type>
          <declname>src</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>len</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="167" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1adf2c97360fea025e25f4446ee11b44f8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int flash_area_erase</definition>
        <argsstring>(const struct flash_area *, uint32_t off, uint32_t len)</argsstring>
        <name>flash_area_erase</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>off</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>len</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="170" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1a55e47cd42c75b21e19716a2e94c9a94d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>size_t</type>
        <definition>size_t flash_area_align</definition>
        <argsstring>(const struct flash_area *)</argsstring>
        <name>flash_area_align</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="172" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1ace9eb5a8253335264f5fa9620008d10b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint8_t</type>
        <definition>uint8_t flash_area_erased_val</definition>
        <argsstring>(const struct flash_area *fap)</argsstring>
        <name>flash_area_erased_val</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
          <declname>fap</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="178" />
      </memberdef>
      <memberdef const="no" explicit="no" id="flash__map__backend_8h_1a61f2c4d83698d32aa971fccdbb6f777c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int flash_area_read_is_empty</definition>
        <argsstring>(const struct flash_area *fa, uint32_t off, void *dst, uint32_t len)</argsstring>
        <name>flash_area_read_is_empty</name>
        <param>
          <type>const struct <ref kindref="compound" refid="structflash__area">flash_area</ref> *</type>
          <declname>fa</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>off</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>dst</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>len</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" line="185" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/*</highlight></codeline>
<codeline lineno="2"><highlight class="comment"><sp />*<sp />Copyright<sp />(c)<sp />2018<sp />Nordic<sp />Semiconductor<sp />ASA</highlight></codeline>
<codeline lineno="3"><highlight class="comment"><sp />*<sp />Copyright<sp />(c)<sp />2015<sp />Runtime<sp />Inc</highlight></codeline>
<codeline lineno="4"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="5"><highlight class="comment"><sp />*<sp />SPDX-License-Identifier:<sp />Apache-2.0</highlight></codeline>
<codeline lineno="6"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="7"><highlight class="normal"><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline lineno="8"><highlight class="comment"><sp />*<sp />Licensed<sp />to<sp />the<sp />Apache<sp />Software<sp />Foundation<sp />(ASF)<sp />under<sp />one</highlight></codeline>
<codeline lineno="9"><highlight class="comment"><sp />*<sp />or<sp />more<sp />contributor<sp />license<sp />agreements.<sp /><sp />See<sp />the<sp />NOTICE<sp />file</highlight></codeline>
<codeline lineno="10"><highlight class="comment"><sp />*<sp />distributed<sp />with<sp />this<sp />work<sp />for<sp />additional<sp />information</highlight></codeline>
<codeline lineno="11"><highlight class="comment"><sp />*<sp />regarding<sp />copyright<sp />ownership.<sp /><sp />The<sp />ASF<sp />licenses<sp />this<sp />file</highlight></codeline>
<codeline lineno="12"><highlight class="comment"><sp />*<sp />to<sp />you<sp />under<sp />the<sp />Apache<sp />License,<sp />Version<sp />2.0<sp />(the</highlight></codeline>
<codeline lineno="13"><highlight class="comment"><sp />*<sp />"License");<sp />you<sp />may<sp />not<sp />use<sp />this<sp />file<sp />except<sp />in<sp />compliance</highlight></codeline>
<codeline lineno="14"><highlight class="comment"><sp />*<sp />with<sp />the<sp />License.<sp /><sp />You<sp />may<sp />obtain<sp />a<sp />copy<sp />of<sp />the<sp />License<sp />at</highlight></codeline>
<codeline lineno="15"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="16"><highlight class="comment"><sp />*<sp /><sp />http://www.apache.org/licenses/LICENSE-2.0</highlight></codeline>
<codeline lineno="17"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="18"><highlight class="comment"><sp />*<sp />Unless<sp />required<sp />by<sp />applicable<sp />law<sp />or<sp />agreed<sp />to<sp />in<sp />writing,</highlight></codeline>
<codeline lineno="19"><highlight class="comment"><sp />*<sp />software<sp />distributed<sp />under<sp />the<sp />License<sp />is<sp />distributed<sp />on<sp />an</highlight></codeline>
<codeline lineno="20"><highlight class="comment"><sp />*<sp />"AS<sp />IS"<sp />BASIS,<sp />WITHOUT<sp />WARRANTIES<sp />OR<sp />CONDITIONS<sp />OF<sp />ANY</highlight></codeline>
<codeline lineno="21"><highlight class="comment"><sp />*<sp />KIND,<sp />either<sp />express<sp />or<sp />implied.<sp /><sp />See<sp />the<sp />License<sp />for<sp />the</highlight></codeline>
<codeline lineno="22"><highlight class="comment"><sp />*<sp />specific<sp />language<sp />governing<sp />permissions<sp />and<sp />limitations</highlight></codeline>
<codeline lineno="23"><highlight class="comment"><sp />*<sp />under<sp />the<sp />License.</highlight></codeline>
<codeline lineno="24"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal"><sp /></highlight><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="26"><highlight class="comment">*<sp />\copyright</highlight></codeline>
<codeline lineno="27"><highlight class="comment">*</highlight></codeline>
<codeline lineno="28"><highlight class="comment">*<sp />(c)<sp />2019,<sp />Cypress<sp />Semiconductor<sp />Corporation</highlight></codeline>
<codeline lineno="29"><highlight class="comment">*<sp />or<sp />a<sp />subsidiary<sp />of<sp />Cypress<sp />Semiconductor<sp />Corporation.<sp />All<sp />rights</highlight></codeline>
<codeline lineno="30"><highlight class="comment">*<sp />reserved.</highlight></codeline>
<codeline lineno="31"><highlight class="comment">*</highlight></codeline>
<codeline lineno="32"><highlight class="comment">*<sp />This<sp />software<sp />is<sp />a<sp />port<sp />of<sp />the<sp />open<sp />source<sp />MCUBoot<sp />project.</highlight></codeline>
<codeline lineno="33"><highlight class="comment">*</highlight></codeline>
<codeline lineno="34"><highlight class="comment">*<sp />This<sp />file<sp />was<sp />modified<sp />to<sp />fit<sp />PSoC6-based<sp />MCUBoot<sp />applications.</highlight></codeline>
<codeline lineno="35"><highlight class="comment">*</highlight></codeline>
<codeline lineno="36"><highlight class="comment">*<sp />Portions<sp />of<sp />this<sp />software,<sp />including<sp />source<sp />code,<sp />documentation<sp />and<sp />related</highlight></codeline>
<codeline lineno="37"><highlight class="comment">*<sp />materials<sp />("Software"),<sp />are<sp />owned<sp />by<sp />Cypress<sp />Semiconductor</highlight></codeline>
<codeline lineno="38"><highlight class="comment">*<sp />Corporation<sp />or<sp />one<sp />of<sp />its<sp />subsidiaries<sp />("Cypress")<sp />and<sp />is<sp />protected<sp />by</highlight></codeline>
<codeline lineno="39"><highlight class="comment">*<sp />and<sp />subject<sp />to<sp />worldwide<sp />patent<sp />protection<sp />(United<sp />States<sp />and<sp />foreign),</highlight></codeline>
<codeline lineno="40"><highlight class="comment">*<sp />United<sp />States<sp />copyright<sp />laws<sp />and<sp />international<sp />treaty<sp />provisions.</highlight></codeline>
<codeline lineno="41"><highlight class="comment">*<sp />Therefore,<sp />you<sp />may<sp />use<sp />this<sp />Software<sp />only<sp />as<sp />provided<sp />in<sp />the<sp />license</highlight></codeline>
<codeline lineno="42"><highlight class="comment">*<sp />agreement<sp />accompanying<sp />the<sp />software<sp />package<sp />from<sp />which<sp />you</highlight></codeline>
<codeline lineno="43"><highlight class="comment">*<sp />obtained<sp />this<sp />Software<sp />("EULA").</highlight></codeline>
<codeline lineno="44"><highlight class="comment">*</highlight></codeline>
<codeline lineno="45"><highlight class="comment">*<sp />If<sp />no<sp />EULA<sp />applies,<sp />Cypress<sp />hereby<sp />grants<sp />you<sp />a<sp />personal,<sp />non-</highlight></codeline>
<codeline lineno="46"><highlight class="comment">*<sp />exclusive,<sp />non-transferable<sp />license<sp />to<sp />copy,<sp />modify,<sp />and<sp />compile<sp />the</highlight></codeline>
<codeline lineno="47"><highlight class="comment">*<sp />Software<sp />source<sp />code<sp />solely<sp />for<sp />use<sp />in<sp />connection<sp />with<sp />Cypress's</highlight></codeline>
<codeline lineno="48"><highlight class="comment">*<sp />integrated<sp />circuit<sp />products.<sp />Any<sp />reproduction,<sp />modification,<sp />translation,</highlight></codeline>
<codeline lineno="49"><highlight class="comment">*<sp />compilation,<sp />or<sp />representation<sp />of<sp />this<sp />Software<sp />except<sp />as<sp />specified</highlight></codeline>
<codeline lineno="50"><highlight class="comment">*<sp />above<sp />is<sp />prohibited<sp />without<sp />the<sp />express<sp />written<sp />permission<sp />of<sp />Cypress.</highlight></codeline>
<codeline lineno="51"><highlight class="comment">*</highlight></codeline>
<codeline lineno="52"><highlight class="comment">*<sp />Disclaimer:<sp />THIS<sp />SOFTWARE<sp />IS<sp />PROVIDED<sp />AS-IS,<sp />WITH<sp />NO</highlight></codeline>
<codeline lineno="53"><highlight class="comment">*<sp />WARRANTY<sp />OF<sp />ANY<sp />KIND,<sp />EXPRESS<sp />OR<sp />IMPLIED,<sp />INCLUDING,</highlight></codeline>
<codeline lineno="54"><highlight class="comment">*<sp />BUT<sp />NOT<sp />LIMITED<sp />TO,<sp />NONINFRINGEMENT,<sp />IMPLIED</highlight></codeline>
<codeline lineno="55"><highlight class="comment">*<sp />WARRANTIES<sp />OF<sp />MERCHANTABILITY<sp />AND<sp />FITNESS<sp />FOR<sp />A</highlight></codeline>
<codeline lineno="56"><highlight class="comment">*<sp />PARTICULAR<sp />PURPOSE.<sp />Cypress<sp />reserves<sp />the<sp />right<sp />to<sp />make</highlight></codeline>
<codeline lineno="57"><highlight class="comment">*<sp />changes<sp />to<sp />the<sp />Software<sp />without<sp />notice.<sp />Cypress<sp />does<sp />not<sp />assume<sp />any</highlight></codeline>
<codeline lineno="58"><highlight class="comment">*<sp />liability<sp />arising<sp />out<sp />of<sp />the<sp />application<sp />or<sp />use<sp />of<sp />the<sp />Software<sp />or<sp />any</highlight></codeline>
<codeline lineno="59"><highlight class="comment">*<sp />product<sp />or<sp />circuit<sp />described<sp />in<sp />the<sp />Software.<sp />Cypress<sp />does<sp />not</highlight></codeline>
<codeline lineno="60"><highlight class="comment">*<sp />authorize<sp />its<sp />products<sp />for<sp />use<sp />in<sp />any<sp />products<sp />where<sp />a<sp />malfunction<sp />or</highlight></codeline>
<codeline lineno="61"><highlight class="comment">*<sp />failure<sp />of<sp />the<sp />Cypress<sp />product<sp />may<sp />reasonably<sp />be<sp />expected<sp />to<sp />result<sp />in</highlight></codeline>
<codeline lineno="62"><highlight class="comment">*<sp />significant<sp />property<sp />damage,<sp />injury<sp />or<sp />death<sp />("High<sp />Risk<sp />Product").<sp />By</highlight></codeline>
<codeline lineno="63"><highlight class="comment">*<sp />including<sp />Cypress's<sp />product<sp />in<sp />a<sp />High<sp />Risk<sp />Product,<sp />the<sp />manufacturer</highlight></codeline>
<codeline lineno="64"><highlight class="comment">*<sp />of<sp />such<sp />system<sp />or<sp />application<sp />assumes<sp />all<sp />risk<sp />of<sp />such<sp />use<sp />and<sp />in<sp />doing</highlight></codeline>
<codeline lineno="65"><highlight class="comment">*<sp />so<sp />agrees<sp />to<sp />indemnify<sp />Cypress<sp />against<sp />all<sp />liability.</highlight></codeline>
<codeline lineno="66"><highlight class="comment">*</highlight></codeline>
<codeline lineno="67"><highlight class="comment">********************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal" /><highlight class="preprocessor">#ifndef<sp />__FLASH_MAP_BACKEND_H__</highlight><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal" /><highlight class="preprocessor">#define<sp />__FLASH_MAP_BACKEND_H__</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"mcuboot_config/mcuboot_config.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_flash.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal" /><highlight class="preprocessor">#define<sp />FLASH_DEVICE_INDEX_MASK<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x7F)</highlight><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /><highlight class="preprocessor">#define<sp />FLASH_DEVICE_GET_EXT_INDEX(n)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((n)<sp />&amp;<sp />FLASH_DEVICE_INDEX_MASK)</highlight><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /><highlight class="preprocessor">#define<sp />FLASH_DEVICE_EXTERNAL_FLAG<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x80)</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal" /><highlight class="preprocessor">#define<sp />FLASH_DEVICE_INTERNAL_FLASH<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x7F)</highlight><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="preprocessor">#define<sp />FLASH_DEVICE_EXTERNAL_FLASH(index)<sp /><sp /><sp /><sp /><sp /><sp />(FLASH_DEVICE_EXTERNAL_FLAG<sp />|<sp />index)</highlight><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal" /><highlight class="preprocessor">#ifndef<sp />CY_BOOT_EXTERNAL_DEVICE_INDEX</highlight><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /><highlight class="comment">/*<sp />assume<sp />first(one)<sp />SMIF<sp />device<sp />is<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_BOOT_EXTERNAL_DEVICE_INDEX<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="82"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal" /></codeline>
<codeline lineno="101"><highlight class="preprocessor">#include<sp />&lt;inttypes.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal" /></codeline>
<codeline lineno="110" refid="structflash__area" refkind="compound"><highlight class="keyword">struct<sp /></highlight><highlight class="normal"><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />{</highlight></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp /><ref kindref="member" refid="structflash__area_1acfe73a1f4f00fdf58129b21e5b71f5d4">fa_id</ref>;</highlight></codeline>
<codeline lineno="115"><highlight class="normal" /></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp /><ref kindref="member" refid="structflash__area_1a5d78c6ab00bab1bd0e825743925216a9">fa_device_id</ref>;</highlight></codeline>
<codeline lineno="120"><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />pad16;</highlight></codeline>
<codeline lineno="122"><highlight class="normal" /></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp /><ref kindref="member" refid="structflash__area_1a44fbf0af3ba0e7fa1c3623e7d48e0739">fa_off</ref>;</highlight></codeline>
<codeline lineno="128"><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp /><ref kindref="member" refid="structflash__area_1ac580f8ab560582c02f12e96cb67b0e59">fa_size</ref>;</highlight></codeline>
<codeline lineno="133"><highlight class="normal">};</highlight></codeline>
<codeline lineno="134"><highlight class="normal" /></codeline>
<codeline lineno="142" refid="structflash__sector" refkind="compound"><highlight class="keyword">struct<sp /></highlight><highlight class="normal"><ref kindref="compound" refid="structflash__sector">flash_sector</ref><sp />{</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp /><ref kindref="member" refid="structflash__sector_1a97421370396c491b90685ed0fc618931">fs_off</ref>;</highlight></codeline>
<codeline lineno="147"><highlight class="normal" /></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp /><ref kindref="member" refid="structflash__sector_1a69093e5c1e6884b6ae50be44788c53a0">fs_size</ref>;</highlight></codeline>
<codeline lineno="152"><highlight class="normal">};</highlight></codeline>
<codeline lineno="153"><highlight class="normal" /></codeline>
<codeline lineno="154" refid="structflash__map__entry" refkind="compound"><highlight class="normal" /><highlight class="keyword">struct<sp /></highlight><highlight class="normal"><ref kindref="compound" refid="structflash__map__entry">flash_map_entry</ref><sp />{</highlight></codeline>
<codeline lineno="155"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />magic;</highlight></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal"><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />area;</highlight></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">unsigned</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />ref_count;</highlight></codeline>
<codeline lineno="158"><highlight class="normal">};</highlight></codeline>
<codeline lineno="159"><highlight class="normal" /></codeline>
<codeline lineno="160"><highlight class="normal" /><highlight class="comment">/*&lt;<sp />Opens<sp />the<sp />area<sp />for<sp />use.<sp />id<sp />is<sp />one<sp />of<sp />the<sp />`fa_id`s<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="161"><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />flash_area_open(uint8_t<sp /></highlight><highlight class="keywordtype">id</highlight><highlight class="normal">,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />**);</highlight></codeline>
<codeline lineno="162"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />flash_area_close(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*);</highlight></codeline>
<codeline lineno="163"><highlight class="normal" /><highlight class="comment">/*&lt;<sp />Reads<sp />`len`<sp />bytes<sp />of<sp />flash<sp />memory<sp />at<sp />`off`<sp />to<sp />the<sp />buffer<sp />at<sp />`dst`<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="164"><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />flash_area_read(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*,<sp />uint32_t<sp />off,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*dst,</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />len);</highlight></codeline>
<codeline lineno="166"><highlight class="normal" /><highlight class="comment">/*&lt;<sp />Writes<sp />`len`<sp />bytes<sp />of<sp />flash<sp />memory<sp />at<sp />`off`<sp />from<sp />the<sp />buffer<sp />at<sp />`src`<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="167"><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />flash_area_write(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*,<sp />uint32_t<sp />off,</highlight></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*src,<sp />uint32_t<sp />len);</highlight></codeline>
<codeline lineno="169"><highlight class="normal" /><highlight class="comment">/*&lt;<sp />Erases<sp />`len`<sp />bytes<sp />of<sp />flash<sp />memory<sp />at<sp />`off`<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="170"><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />flash_area_erase(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*,<sp />uint32_t<sp />off,<sp />uint32_t<sp />len);</highlight></codeline>
<codeline lineno="171"><highlight class="normal" /><highlight class="comment">/*&lt;<sp />Returns<sp />this<sp />`flash_area`s<sp />alignment<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="172"><highlight class="normal" /><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />flash_area_align(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*);</highlight></codeline>
<codeline lineno="173"><highlight class="normal" /></codeline>
<codeline lineno="174"><highlight class="normal" /><highlight class="comment">/*</highlight></codeline>
<codeline lineno="175"><highlight class="comment"><sp />*<sp />Returns<sp />the<sp />value<sp />expected<sp />to<sp />be<sp />read<sp />when<sp />accesing<sp />any<sp />erased</highlight></codeline>
<codeline lineno="176"><highlight class="comment"><sp />*<sp />flash<sp />byte.</highlight></codeline>
<codeline lineno="177"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="178"><highlight class="normal">uint8_t<sp />flash_area_erased_val(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*fap);</highlight></codeline>
<codeline lineno="179"><highlight class="normal" /></codeline>
<codeline lineno="180"><highlight class="normal" /><highlight class="comment">/*</highlight></codeline>
<codeline lineno="181"><highlight class="comment"><sp />*<sp />Reads<sp />len<sp />bytes<sp />from<sp />off,<sp />and<sp />checks<sp />if<sp />the<sp />read<sp />data<sp />is<sp />erased.</highlight></codeline>
<codeline lineno="182"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="183"><highlight class="comment"><sp />*<sp />Returns<sp />1<sp />if<sp />erased,<sp />0<sp />if<sp />non-erased,<sp />and<sp />-1<sp />on<sp />failure.</highlight></codeline>
<codeline lineno="184"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />flash_area_read_is_empty(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structflash__area">flash_area</ref><sp />*fa,<sp />uint32_t<sp />off,</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*dst,<sp />uint32_t<sp />len);</highlight></codeline>
<codeline lineno="187"><highlight class="normal" /></codeline>
<codeline lineno="188"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />__FLASH_MAP_BACKEND_H__<sp />*/</highlight><highlight class="preprocessor" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/anycloud-ota/source/mcuboot/cy_flash_pal/include/flash_map_backend/flash_map_backend.h" />
  </compounddef>
</doxygen>